package common;

public class AudioStreamDescriptor extends StreamDescriptor {
	private int bitRate=VALUE_UNKNOWN;
	private String channels;
	private int frequency=VALUE_UNKNOWN;
	/**
	 * Delay in milliseconds
	 */
	private int delay=VALUE_UNKNOWN;
	
	public AudioStreamDescriptor(int stream) {
		super(stream);
		classification=CLASSIFICATION_AUDIO;
	}
	public int getBitRate() {
		return bitRate;
	}
	public String getChannels() {
		return channels;
	}
	public void setBitRate(int bitRate) {
		this.bitRate = bitRate;
	}
	public void setChannels(String channels) {
		this.channels = channels;
	}
	public int getFrequency() {
		return frequency;
	}
	public void setFrequency(int frequency) {
		this.frequency = frequency;
	}
	public int getDelay() {
		return delay;
	}
	public void setDelay(int delay) {
		this.delay=delay;
	}
	public String toString() {
		StringBuffer sb=new StringBuffer(super.toString());
		if (channels != null) {
			sb.append(' ');
			sb.append(channels);
		}
		if (frequency !=VALUE_UNKNOWN) {
			sb.append(' ');
			sb.append(frequency);
			sb.append(" Hz");
		}
		if (bitRate != VALUE_UNKNOWN) {
			sb.append(' ');
			sb.append(bitRate);
			sb.append(" kb/s");
		}
		if (delay != VALUE_UNKNOWN) {
			sb.append(' ');
			sb.append(delay);
			sb.append("ms");
		}
		return sb.toString(); 
	}
}
