package common;

import java.io.IOException;
import java.net.Socket;
import java.nio.ByteBuffer;
import java.nio.channels.SocketChannel;

public class SocketStream implements JobStreamI {
	private Job job;
	private Socket socket;
	//private InputStream in;
	private SocketChannel socketChannel;
	private long streamSize=-1;
	private long position=0;
	
	public SocketStream(Job job,Socket socket) {
		this.job=job;
		this.socket=socket;
	}
	public void close() {
		try {
			socket.close();
		} catch (IOException e) {
		}
	}

	public long getStreamSize() {
		return streamSize;
	}

	public boolean isEOS() throws IOException {
		return socket.isInputShutdown();
	}

	public void open() throws IOException {
		socketChannel=socket.getChannel();
	}

	public byte peek(int offset) throws IOException {
		throw new IOException("SocketStream.peek() not supported");
		/*in.mark(offset);
		skip(offset);
		byte b=(byte)in.read();
		in.reset();
		return b;*/
	}

	public ByteBuffer slice(int len) throws IOException {
		ByteBuffer byteBuffer=ByteBuffer.allocate(len);
		while (socketChannel.read(byteBuffer) > 0 && byteBuffer.remaining() > 0) {}
		position+=len;
		job.setPosition((int)(position/Job.KB));
		return byteBuffer;
	}
	public void reset() throws IOException {
		throw new IOException("Unsupported operation for SocketStream");
	}

	public void setChunkSize(int bytes) {
		//Intentionally blank
	}

	public void setBufferChunks(int chunkSize, int numberOfChunks) {
		//Intentionally blank
	}
	public void setStreamSize(long size) {
		this.streamSize=size;

	}

	public int skip(int bytes) {
		try {
			ByteBuffer buffer=slice(bytes);
			return buffer.position();
		} catch (IOException e) {
			return -1;
		}
	}
	public Job getJob() {
		return job;
	}
	/*public ByteBuffer slice(int len) {
		throw new RuntimeException("Unsupported operation slice(len:int)");
	}*/

}
