package common.avc;

import java.nio.ByteBuffer;

import common.BitStream;

public class AvcPulldown implements AvcConstants {
	public void copySequence(ByteBuffer inBuffer, int start, BitStream outBitStream) {
		BitStream bitStream=new BitStream(inBuffer);
		ByteBuffer outByteBuffer=outBitStream.getByteBuffer();
		outByteBuffer.limit(outByteBuffer.capacity());
		byte profileIdc=bitStream.get();
		outByteBuffer.put(profileIdc);
		
		byte flags=bitStream.get(); //4 flags + 4 zeros
		outByteBuffer.put(flags);
		
		byte levelIdc=bitStream.get();
		outByteBuffer.put(levelIdc);
		//sd.setCodec(CODEC_NAME);
		//sd.setProfileName(profileNameMap.get(Byte.valueOf(profileIdc)));
		//sd.setLevelName(levelIdc/10 + "." + levelIdc%10);
		int seqParameterSetId=bitStream.getExpGolombCode();
		outBitStream.setExpGolombCode(seqParameterSetId);
		
		if (profileIdc==HIGH_PROFILE1 || profileIdc==HIGH_PROFILE2 || profileIdc==HIGH_PROFILE3 || profileIdc==HIGH_PROFILE4) {
			int chromaFormatIdc=bitStream.getExpGolombCode();
			outBitStream.setExpGolombCode(chromaFormatIdc);
			if (chromaFormatIdc==3) {
				int residualColourTransformFlag=bitStream.getBit();
				outBitStream.appendBits(1, residualColourTransformFlag);
			}
			int bitDepthLumaMinus8=bitStream.getExpGolombCode();
			outBitStream.setExpGolombCode(bitDepthLumaMinus8);
			
			int bitDepthChromaMinus8=bitStream.getExpGolombCode();
			outBitStream.setExpGolombCode(bitDepthChromaMinus8);
						
			int qpprimeYZeroTransformBypassFlag=bitStream.getBit();
			outBitStream.appendBits(1, qpprimeYZeroTransformBypassFlag);
			
			int seqScalingMatrixPresentFlag=bitStream.getBit();
			outBitStream.appendBits(1, seqScalingMatrixPresentFlag);
			
			if (seqScalingMatrixPresentFlag==1) {
				for (int i=0;i<8;i++) {
					int seqScalingListPresentFlag=bitStream.getBit();
					outBitStream.appendBits(1, seqScalingListPresentFlag);
					
					if (seqScalingListPresentFlag==1) {
						copyScalingList(bitStream,i<6?16:64, outBitStream);
					}
				}
			}
			int log2MaxFrameNumMinus4=bitStream.getExpGolombCode();
			outBitStream.setExpGolombCode(log2MaxFrameNumMinus4);
			
			int picOrderCntType=bitStream.getExpGolombCode();
			outBitStream.setExpGolombCode(picOrderCntType);
			
			if (picOrderCntType==0) {
				int log2MaxPicOrderCntLsbMinus4=bitStream.getExpGolombCode();
				outBitStream.setExpGolombCode(log2MaxPicOrderCntLsbMinus4);
			} else if (picOrderCntType==1) {
				int deltaPicOrderAlwaysZeroFlag=bitStream.getBit();
				outBitStream.appendBits(1, deltaPicOrderAlwaysZeroFlag);
				
				int offsetForNonRefPic=bitStream.getExpGolombCode();//TODO: Signed
				outBitStream.setExpGolombCode(offsetForNonRefPic);
				
				int offsetForTopToBottomField=bitStream.getExpGolombCode();//TODO: Signed
				outBitStream.setExpGolombCode(offsetForTopToBottomField);
				
				int numRefFramesInPicOrderCntCycle=bitStream.getExpGolombCode();
				outBitStream.setExpGolombCode(numRefFramesInPicOrderCntCycle);
				
				for (int i=0;i<numRefFramesInPicOrderCntCycle;i++) {
					int v=bitStream.getExpGolombCode();//TODO: Signed
					outBitStream.setExpGolombCode(v);
				}
			}
			int numRefFrames=bitStream.getExpGolombCode();
			outBitStream.setExpGolombCode(numRefFrames);
			
			int gapsInFrameNumValueAllowedFlag=bitStream.getBit();
			outBitStream.appendBits(1, 0);
			
			int picWidthInMbsMinus1=bitStream.getExpGolombCode();
			outBitStream.setExpGolombCode(picWidthInMbsMinus1);
			
			int picHeightInMapUnitsMinus1=bitStream.getExpGolombCode();
			outBitStream.setExpGolombCode(picHeightInMapUnitsMinus1);
			
			int frameMbsOnlyFlag=bitStream.getBit();
			outBitStream.appendBits(1, frameMbsOnlyFlag);//TODO: Change to 1?
			//Derived this all on my lonesome, not 100% sure it is accurate
			//sd.setInterlaced(1-frameMbsOnlyFlag);
			if (frameMbsOnlyFlag==0) {
				int mbAdaptiveFrameFieldFlag=bitStream.getBit();
				outBitStream.appendBits(1, mbAdaptiveFrameFieldFlag);
			}
			int direct8x8InferenceFlag=bitStream.getBit();
			outBitStream.appendBits(1, direct8x8InferenceFlag);
			
			int frameCroppingFlag=bitStream.getBit();
			outBitStream.appendBits(1, frameCroppingFlag);
			
			int frameCropLeftOffset=0,frameCropRightOffset=0,frameCropTopOffset=0,frameCropBottomOffset=0;
			if (frameCroppingFlag==1) {
				frameCropLeftOffset=bitStream.getExpGolombCode();
				outBitStream.setExpGolombCode(frameCropLeftOffset);
				
				frameCropRightOffset=bitStream.getExpGolombCode();
				outBitStream.setExpGolombCode(frameCropRightOffset);
				
				frameCropTopOffset=bitStream.getExpGolombCode();
				outBitStream.setExpGolombCode(frameCropTopOffset);
				
				frameCropBottomOffset=bitStream.getExpGolombCode();
				outBitStream.setExpGolombCode(frameCropBottomOffset);
			}
			//Borrowed heavily from 
		    int width =(picWidthInMbsMinus1       +1)*16;
		    int height=(picHeightInMapUnitsMinus1+1)*16*(2-frameMbsOnlyFlag);
		    int cropUnitX=SUB_WIDTH_C[chromaFormatIdc];
		    int cropUnitY=SUB_HEIGHT_C[chromaFormatIdc]*(2-frameMbsOnlyFlag);
		    width -=(frameCropLeftOffset+frameCropRightOffset )*cropUnitX;
		    height-=(frameCropTopOffset +frameCropBottomOffset)*cropUnitY;
			int vuiParametersPresentFlag=bitStream.getBit();
			outBitStream.appendBits(1, vuiParametersPresentFlag);
			
			if (vuiParametersPresentFlag==1) {
				int aspectRatioIdc=-1;
				int aspectRatioInfoPresentFlag=bitStream.getBit();
				outBitStream.appendBits(1, aspectRatioInfoPresentFlag);
				
				if (aspectRatioInfoPresentFlag==1) {
					aspectRatioIdc=bitStream.getBits(8);
					outBitStream.appendBits(8, aspectRatioIdc);
					if (aspectRatioIdc==EXTENDED_SAR) {
						int har=bitStream.getBits(16);
						int var=bitStream.getBits(16);
						outBitStream.appendBits(16, har);
						outBitStream.appendBits(16, var);
						//sd.setPixelAspectRatio(new int[] {har,var});
						
					} 
				}
				
				int overscanInfoPresentFlag=bitStream.getBit();
				outBitStream.appendBits(1, overscanInfoPresentFlag);
				
				if (overscanInfoPresentFlag==1) {
					int overscanAppropriateFlag=bitStream.getBit(); // overscan_appropriate_flag
					outBitStream.appendBits(1, overscanAppropriateFlag);
				}
				int videoSignalTypePresentFlag=bitStream.getBit();
				outBitStream.appendBits(1, videoSignalTypePresentFlag);
				if (videoSignalTypePresentFlag==1) {
					int videoFormat=bitStream.getBits(3);
					outBitStream.appendBits(3, videoFormat);
					
					int videoFullRangeFlag=bitStream.getBit();
					outBitStream.appendBits(1, videoFullRangeFlag);
					
					int colourDescriptionPresentFlag=bitStream.getBit();
					outBitStream.appendBits(1, colourDescriptionPresentFlag);
					
					if (colourDescriptionPresentFlag==1) {
						int colourPrimaries=bitStream.getBits(8);
						outBitStream.appendBits(8, colourPrimaries);
						
						int transferCharacteristics=bitStream.getBits(8);
						outBitStream.appendBits(8, transferCharacteristics);
						
						int matrixCoefficients=bitStream.getBits(8);
						outBitStream.appendBits(8, matrixCoefficients);
					}
				}
				int chromaLocInfoPresentFlag=bitStream.getBit();
				outBitStream.appendBits(1, chromaLocInfoPresentFlag);
				
				if (chromaLocInfoPresentFlag==1) {
					int chromaSampleLocTypeTopField=bitStream.getExpGolombCode();
					outBitStream.setExpGolombCode(chromaSampleLocTypeTopField);
					
					int chromaSampleLocTypeBottomField=bitStream.getExpGolombCode();
					outBitStream.setExpGolombCode(chromaSampleLocTypeBottomField);
				}
				//F___ing finally
				int timingInfoPresentFlag=bitStream.getBit();
				outBitStream.appendBits(1, timingInfoPresentFlag);
				
				if (timingInfoPresentFlag==1) {
					int numUnitsInTickHi=bitStream.getBits(16);
					int numUnitsInTickLo=bitStream.getBits(16);
					int numUnitsInTick=(numUnitsInTickHi << 16) + numUnitsInTickLo;
					outBitStream.appendBits(16, numUnitsInTickHi);
					outBitStream.appendBits(16, numUnitsInTickLo);
					
					int factor=numUnitsInTick/1001;
					int timeScale=(bitStream.getBits(16) << 16) + bitStream.getBits(16);
					if (timeScale/factor != 60000) {
						throw new RuntimeException("Frame is " + timeScale/(factor * 2) + "/" + numUnitsInTick/factor + ".  A frame rate of 30000/1001 is required."); 
					}
					timeScale=timeScale*4/5;
					outBitStream.appendBits(16, timeScale>>>16);
					outBitStream.appendBits(16, timeScale & 0xffff);
					
					int fixedFrameRateFlag=bitStream.getBit();
					outBitStream.appendBits(1, fixedFrameRateFlag);
					
					//sd.setFrameRateRatio(new int[]{timeScale/2,numUnitsInTick});
				}
			}
			outBitStream.appendFrom(bitStream);
		}
	}
	private void copyScalingList(BitStream bitStream, int scalingListSize, BitStream outBitStream) {
	    //From http://mpeg4ip.cvs.sourceforge.net/mpeg4ip/mpeg4ip/util/h264/main.cpp?revision=1.17&view=markup
	    int lastScale=8, nextScale=8;
	    for (int pos=0; pos<scalingListSize; pos++)
	    {
	        if (nextScale!=0)
	        {
	            int deltaScale=bitStream.getExpGolombCode();
	            outBitStream.setExpGolombCode(deltaScale);
	            nextScale=(lastScale+deltaScale+256)%256;
	        }
	        lastScale=nextScale;
	    }	
	}
}
