package common.packet;

import java.util.Collection;
import java.util.Iterator;


public class PacketList implements Collection {
	private Packet list[];
	int start=0;
	int end=0;
	
	public PacketList() {
		this(60);
	}
	public PacketList(int initial) {
		list=new Packet[initial];
	}
	public boolean add(Object o) {
		return false;
	}
	public boolean addAll(Collection c) {
		boolean b=true;
		for (Iterator i=c.iterator();i.hasNext();) {
			b&=add(i.next());
		}
		return b;
	}
	public boolean contains(Object o) {
		for (int i=start;i<end;i++) {
			if (o.equals(list[i])) {
				return true;
			}
		}
		return false;
	}
	public boolean containsAll(Collection c) {
		for (Iterator i=c.iterator();i.hasNext();) {
			if (!contains(i.next())) {
				return false;
			}
		}
		return true;
	}
	public Iterator iterator() {
		return new Iterator() {
			int i=start;
			public boolean hasNext() {
				return i<end;
			}
			public Object next() {
				return get(i++);
			}
			public void remove() {
				throw new RuntimeException("Unsupported");
			}
		};
	}
	public boolean removeAll(Collection c) {
		throw new RuntimeException("Unsupported");
	}
	public boolean retainAll(Collection c) {
		throw new RuntimeException("Unsupported");
	}
	public Object[] toArray() {
		return toArray(new Packet[size()]);
	}
	public Object[] toArray(Object[] o) {
		throw new RuntimeException("Unsupported");
	}
	public void add(Packet packet) {
		if (list.length==end) {
			if (start==0) {
				Packet oldList[]=list;
				list=new Packet[list.length + 10];
				//System.out.println("PacketList grew " + list.length);
				System.arraycopy(oldList, 0, list, 0, oldList.length);
			} else {
				//System.out.println("Packed PacketList " + start);
				System.arraycopy(list, start, list, 0, end-start);
				int newEnd=end-start;
				clear(newEnd, end);
				end=newEnd;
				start=0;
			}
		}
		list[end++]=packet;
	}
	public Packet get(int i) {
		return list[i + start];
	}
	public int size() {
		return end-start;
	}
	public boolean remove(Object o) {
		for (int i=start;i<end;i++) {
			if (o.equals(list[i])) {
				remove(i);
				return true;
			}
		}
		return false;
	}
	public Packet remove(int i) {
		Packet packet;
		if (i==0) {
			//"Remove" the first packet
			packet=list[start];
			list[start]=null;
			start++;
		} else if (end-start-1==i) {
			//"Remove" the last packet
			packet=list[--end];
			list[end]=null;
		} else {
			//This shouldn't happen very often
			//Splice the array
			packet=list[start + i];
			System.arraycopy(list, start + i + 1, list, start + i, end-start-i);
			end--;
		}
		return packet;
	}
	
	public String toString() {
		StringBuffer out=new StringBuffer();
		char sep='[';
		for (int i=start;i<end;i++) {
			out.append(sep);
			out.append(list[i]);
			sep=',';
		}
		out.append(']');
		return out.toString();
	}
	public boolean isEmpty() {
		return start==end;
	}
	public static void main(String args[]) {
		
		PacketList list=new PacketList();
		for (int i=0;i<10;i++) {
			list.add(new Packet(0,i));
		}
		list.remove(0);
		list.remove(8);
		list.remove(3);//"4"
		System.out.println(list);
		for (int i=10;i<65;i++) {
			list.add(new Packet(0,i));
		}
		System.out.println(list);
	}
	public void clear() {
		clear(start,end);
		start=end=0;
	}
	private void clear(int start, int end) {
		for (int i=start;i<end;i++) {
			list[i]=null;
		}
	}
}
