package demux;

import java.io.IOException;
import java.util.List;
import java.util.Map;

import muxer.MuxManager;

import common.Logger;
import common.StreamDescriptor;
import common.JobStreamI;
import common.packet.Packet;

public abstract class Demuxer {
	protected Logger logger=Logger.getLogger(this.getClass());
	protected int streamIds[]=new int[0];
	
	public abstract void parse(JobStreamI stream, MuxManager muxManager) throws IOException;
	
	public abstract Map<Integer, StreamDescriptor> getStreamDescriptorMap(JobStreamI stream, MuxManager muxManager) throws IOException;

	public void returnToCache(Packet packet) {
		//No default cache
	}
	
	public void setStreams(List<StreamDescriptor> streamDescriptorList) {
		streamIds=new int[streamDescriptorList.size()];
		for (int i=0;i<streamDescriptorList.size();i++) {
			StreamDescriptor streamDescriptor=streamDescriptorList.get(i);
			streamIds[i]=streamDescriptor.getStreamId();
		}
	}

	
	final public static boolean isCopied(int streamId, int streamIds[]) {
		if (streamIds.length==0) {
			return true;
		}
		for (int i=0;i<streamIds.length;i++) {
			if (streamIds[i]==streamId) {
				return true;
			}
		}
		return false;
	}
	final public boolean isCopied(int streamId) {
		return isCopied(streamId, streamIds);
	}
	final public int[] getStreamIds() {
		return streamIds;
	}
}
